import turtle
import random

from x_candle import Candle
from x_sphere import Sphere
from x_star import Star
from x_tree import ChristmasTree

# Main function to draw a random Christmas tree
def draw_random_christmas_tree():
    turtle.speed(0)
    turtle.hideturtle()

    # Draw the Christmas tree
    tree = ChristmasTree(0, -200, 300, levels=random.randint(3, 5))

    # Draw a star on top
    star = Star(-15, 69, 30)
    tree.addObject(star)

    # Randomly place spheres and candles
    for i in range(random.randint(10, 20)):
        onTree = False
        while(not onTree):
            x = random.randint(-100, 100)
            y = random.randint(-200, 100)
            if random.choice([True, False]):
                sphere = Sphere(x, y, 10, random.choice(["red", "blue", "gold"]))
                onTree = tree.addObject(sphere)
            else:
                candle = Candle(x, y, 30)
                onTree = tree.addObject(candle)
    tree.draw()

# Run the script
if __name__ == "__main__":
    turtle.setup(width=800, height=600) # Set the window size if the image
    draw_random_christmas_tree()
    turtle.done()