import turtle
from tree_object import TreeObject

# Candle Class
class Candle(TreeObject):
    def __init__(self, x, y, height, color="red"):
        super().__init__(x, y)
        self.height = height
        self.color = color

    def draw(self):
        # Draw the candle body
        turtle.penup()
        turtle.goto(self.x, self.y)
        turtle.color(self.color)
        turtle.pendown()
        turtle.begin_fill()
        for _ in range(2):
            turtle.forward(10)
            turtle.left(90)
            turtle.forward(self.height)
            turtle.left(90)
        turtle.end_fill()

        # Draw the flame
        turtle.penup()
        turtle.goto(self.x + 5, self.y + self.height)
        turtle.color("orange")
        turtle.begin_fill()
        turtle.circle(5)
        turtle.end_fill()