# ChristmasTree Class
import turtle
from tree_object import TreeObject

class ChristmasTree:
    def __init__(self, x, y, size, levels=3):
        self.size = size
        self.levels = levels
        self.x = x
        self.y = y
        self.objects = []

    def addObject(self, obj):
        greenY = self.y
        greenHeight = self.size - self.size//10
        greenWidth = self.size//2 - 10
        # Only add object if it's on the tree
        if obj.y > greenY and obj.y < (greenY + greenHeight):
            width_of_y = greenWidth - obj.y * greenWidth//greenHeight
            if obj.x > (self.x - width_of_y//2)  and obj.x < (self.x + width_of_y//2):
                self.objects.append(obj)
            return True
        return False

    def drawTrunk(self):
        # Draw the tree trunk
        trunk_width = self.size // 10
        trunk_height = self.size // 5
        turtle.penup()
        turtle.goto(self.x - trunk_width // 2, self.y - trunk_height)
        turtle.color("brown")
        turtle.pendown()
        turtle.begin_fill()
        for _ in range(2):
            turtle.forward(trunk_width)
            turtle.left(90)
            turtle.forward(trunk_height)
            turtle.left(90)
        turtle.end_fill()

    def drawTree(self):
        # Draw the tree levels
        turtle.color("green")
        for level in range(self.levels):
            level_width = self.size - level * (self.size // 5)
            level_height = self.size // 4
            turtle.penup()
            turtle.goto(self.x - level_width // 2, self.y + level * level_height)
            turtle.pendown()
            turtle.begin_fill()
            for _ in range(3):
                turtle.forward(level_width)
                turtle.left(120)
            turtle.end_fill()

    def draw(self):
        # Draw the tree trunk
        self.drawTrunk()
        # Draw the tree
        self.drawTree()

        # Draw the objects
        for obj in self.objects:
            obj.draw()